diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/he/he-phy.cc ns-3.41/src/wifi/model/he/he-phy.cc
--- ns-3.40/src/wifi/model/he/he-phy.cc	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/he/he-phy.cc	2024-02-09 14:44:08.585795000 -0800
@@ -461,9 +461,8 @@
     // detection window. If a preamble is received after the preamble detection window, it is stored
     // anyway because this is needed for HE TB PPDUs in order to properly update the received power
     // in InterferenceHelper. The map is cleaned anyway at the end of the current reception.
-    const auto uidPreamblePair = std::make_pair(ppdu->GetUid(), ppdu->GetPreamble());
     const auto& currentPreambleEvents = GetCurrentPreambleEvents();
-    const auto it = currentPreambleEvents.find(uidPreamblePair);
+    const auto it = currentPreambleEvents.find({ppdu->GetUid(), ppdu->GetPreamble()});
     if (const auto isResponseToTrigger = (m_previouslyTxPpduUid == ppdu->GetUid());
         ppdu->GetType() == WIFI_PPDU_TYPE_UL_MU || isResponseToTrigger)
     {
@@ -704,6 +703,12 @@
     m_obssPdAlgorithm = algorithm;
 }
 
+Ptr<ObssPdAlgorithm>
+HePhy::GetObssPdAlgorithm() const
+{
+    return m_obssPdAlgorithm;
+}
+
 void
 HePhy::SetEndOfHeSigACallback(EndOfHeSigACallback callback)
 {
@@ -836,8 +841,8 @@
     {
         NS_LOG_DEBUG("Receiving PSDU in HE TB PPDU");
         uint16_t staId = GetStaId(ppdu);
-        m_signalNoiseMap.insert({std::make_pair(ppdu->GetUid(), staId), SignalNoiseDbm()});
-        m_statusPerMpduMap.insert({std::make_pair(ppdu->GetUid(), staId), std::vector<bool>()});
+        m_signalNoiseMap.insert({{ppdu->GetUid(), staId}, SignalNoiseDbm()});
+        m_statusPerMpduMap.insert({{ppdu->GetUid(), staId}, std::vector<bool>()});
         // for HE TB PPDUs, ScheduleEndOfMpdus and EndReceive are scheduled by
         // StartReceiveMuPayload
         NS_ASSERT(!m_beginMuPayloadRxEvents.empty());
@@ -858,7 +863,6 @@
                           const std::vector<bool>& statusPerMpdu)
 {
     NS_LOG_FUNCTION(this << *psdu << txVector);
-    m_state->NotifyRxPsduSucceeded(psdu, rxSignalInfo, txVector, staId, statusPerMpdu);
     if (!IsUlMu(txVector.GetPreambleType()))
     {
         m_state->SwitchFromRxEndOk();
@@ -873,7 +877,6 @@
 HePhy::RxPayloadFailed(Ptr<const WifiPsdu> psdu, double snr, const WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this << *psdu << txVector << snr);
-    m_state->NotifyRxPsduFailed(psdu, snr);
     if (!txVector.IsUlMu())
     {
         m_state->SwitchFromRxEndError();
@@ -959,8 +962,8 @@
     m_endRxPayloadEvents.push_back(
         Simulator::Schedule(payloadDuration, &HePhy::EndReceivePayload, this, event));
     uint16_t staId = GetStaId(ppdu);
-    m_signalNoiseMap.insert({std::make_pair(ppdu->GetUid(), staId), SignalNoiseDbm()});
-    m_statusPerMpduMap.insert({std::make_pair(ppdu->GetUid(), staId), std::vector<bool>()});
+    m_signalNoiseMap.insert({{ppdu->GetUid(), staId}, SignalNoiseDbm()});
+    m_statusPerMpduMap.insert({{ppdu->GetUid(), staId}, std::vector<bool>()});
     // Notify the MAC about the start of a new HE TB PPDU, so that it can reschedule the timeout
     NotifyPayloadBegin(ppdu->GetTxVector(), payloadDuration);
 }
@@ -990,14 +993,12 @@
         channelWidth,
         ru.GetRuType(),
         ru.GetPhyIndex(channelWidth, m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20)));
-    HeRu::SubcarrierRange subcarrierRange =
-        std::make_pair(group.front().first, group.back().second);
     // for a TX spectrum, the guard bandwidth is a function of the transmission channel width
     // and the spectrum width equals the transmission channel width (hence bandIndex equals 0)
     auto indices = ConvertHeRuSubcarriers(channelWidth,
                                           GetGuardBandwidth(channelWidth),
                                           m_wifiPhy->GetSubcarrierSpacing(),
-                                          subcarrierRange,
+                                          {group.front().first, group.back().second},
                                           0);
     auto frequencies = m_wifiPhy->ConvertIndicesToFrequencies(indices);
     return {indices, frequencies};
@@ -1014,15 +1015,13 @@
         channelWidth,
         ru.GetRuType(),
         ru.GetPhyIndex(channelWidth, m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20)));
-    HeRu::SubcarrierRange subcarrierRange =
-        std::make_pair(group.front().first, group.back().second);
     // for an RX spectrum, the guard bandwidth is a function of the operating channel width
     // and the spectrum width equals the operating channel width
     auto indices = ConvertHeRuSubcarriers(
         channelWidth,
         GetGuardBandwidth(m_wifiPhy->GetChannelWidth()),
         m_wifiPhy->GetSubcarrierSpacing(),
-        subcarrierRange,
+        {group.front().first, group.back().second},
         m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(channelWidth));
     auto frequencies = m_wifiPhy->ConvertIndicesToFrequencies(indices);
     return {indices, frequencies};
@@ -1047,13 +1046,11 @@
         nonOfdmaRu.GetRuType(),
         nonOfdmaRu.GetPhyIndex(channelWidth,
                                m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20)));
-    HeRu::SubcarrierRange subcarrierRange =
-        std::make_pair(groupPreamble.front().first, groupPreamble.back().second);
     auto indices = ConvertHeRuSubcarriers(
         channelWidth,
         GetGuardBandwidth(m_wifiPhy->GetChannelWidth()),
         m_wifiPhy->GetSubcarrierSpacing(),
-        subcarrierRange,
+        {groupPreamble.front().first, groupPreamble.back().second},
         m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(channelWidth));
     auto frequencies = m_wifiPhy->ConvertIndicesToFrequencies(indices);
     return {indices, frequencies};
@@ -1580,7 +1577,7 @@
     {                                                                                              \
         static WifiMode mcs = CreateHeMcs(x);                                                      \
         return mcs;                                                                                \
-    };
+    }
 
 GET_HE_MCS(0)
 GET_HE_MCS(1)
@@ -1764,7 +1761,7 @@
         staId = txVector.GetHeMuUserInfoMap().begin()->first;
     }
 
-    return WifiConstPsduMap({std::make_pair(staId, psdu)});
+    return WifiConstPsduMap({{staId, psdu}});
 }
 
 uint32_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/he/he-phy.h ns-3.41/src/wifi/model/he/he-phy.h
--- ns-3.40/src/wifi/model/he/he-phy.h	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/he/he-phy.h	2024-02-09 14:44:08.585795000 -0800
@@ -233,6 +233,13 @@
     void SetObssPdAlgorithm(const Ptr<ObssPdAlgorithm> algorithm);
 
     /**
+     * Gets the OBSS-PD algorithm.
+     *
+     * \return the OBSS-PD algorithm
+     */
+    Ptr<ObssPdAlgorithm> GetObssPdAlgorithm() const;
+
+    /**
      * Set a callback for a end of HE-SIG-A.
      *
      * \param callback the EndOfHeSigACallback to set
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/he/multi-user-scheduler.cc ns-3.41/src/wifi/model/he/multi-user-scheduler.cc
--- ns-3.40/src/wifi/model/he/multi-user-scheduler.cc	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/he/multi-user-scheduler.cc	2024-02-09 14:44:08.585795000 -0800
@@ -57,7 +57,7 @@
                           "The Access Category for which the MultiUserScheduler makes requests "
                           "for channel access.",
                           EnumValue(AcIndex::AC_BE),
-                          MakeEnumAccessor(&MultiUserScheduler::m_accessReqAc),
+                          MakeEnumAccessor<AcIndex>(&MultiUserScheduler::m_accessReqAc),
                           MakeEnumChecker(AcIndex::AC_BE,
                                           "AC_BE",
                                           AcIndex::AC_VI,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/he/rr-multi-user-scheduler.cc ns-3.41/src/wifi/model/he/rr-multi-user-scheduler.cc
--- ns-3.40/src/wifi/model/he/rr-multi-user-scheduler.cc	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/he/rr-multi-user-scheduler.cc	2024-02-09 14:44:08.585795000 -0800
@@ -320,7 +320,8 @@
     m_txParams.Clear();
     // set the TXVECTOR used to send the Trigger Frame
     m_txParams.m_txVector =
-        m_apMac->GetWifiRemoteStationManager(m_linkId)->GetRtsTxVector(m_triggerMacHdr.GetAddr1());
+        m_apMac->GetWifiRemoteStationManager(m_linkId)->GetRtsTxVector(m_triggerMacHdr.GetAddr1(),
+                                                                       m_allowedWidth);
 
     if (!GetHeFem(m_linkId)->TryAddMpdu(item, m_txParams, m_availableTime))
     {
@@ -442,7 +443,8 @@
     m_txParams.Clear();
     // set the TXVECTOR used to send the Trigger Frame
     m_txParams.m_txVector =
-        m_apMac->GetWifiRemoteStationManager(m_linkId)->GetRtsTxVector(m_triggerMacHdr.GetAddr1());
+        m_apMac->GetWifiRemoteStationManager(m_linkId)->GetRtsTxVector(m_triggerMacHdr.GetAddr1(),
+                                                                       m_allowedWidth);
 
     if (!GetHeFem(m_linkId)->TryAddMpdu(item, m_txParams, m_availableTime))
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/ht/ht-frame-exchange-manager.cc ns-3.41/src/wifi/model/ht/ht-frame-exchange-manager.cc
--- ns-3.40/src/wifi/model/ht/ht-frame-exchange-manager.cc	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/ht/ht-frame-exchange-manager.cc	2024-02-09 14:44:08.585795000 -0800
@@ -23,10 +23,11 @@
 #include "ns3/assert.h"
 #include "ns3/ctrl-headers.h"
 #include "ns3/log.h"
-#include "ns3/mgt-headers.h"
+#include "ns3/mgt-action-headers.h"
 #include "ns3/recipient-block-ack-agreement.h"
 #include "ns3/snr-tag.h"
 #include "ns3/sta-wifi-mac.h"
+#include "ns3/vht-configuration.h"
 #include "ns3/wifi-mac-queue.h"
 #include "ns3/wifi-utils.h"
 
@@ -109,7 +110,7 @@
     Ptr<QosTxop> qosTxop = m_mac->GetQosTxop(tid);
     bool establish;
 
-    if (!GetWifiRemoteStationManager()->GetHtSupported(recipient))
+    if (!m_mac->GetHtSupported(recipient))
     {
         establish = false;
     }
@@ -126,7 +127,7 @@
             ((qosTxop->GetBlockAckThreshold() > 0 && packets >= qosTxop->GetBlockAckThreshold()) ||
              (m_mpduAggregator->GetMaxAmpduSize(recipient, tid, WIFI_MOD_CLASS_HT) > 0 &&
               packets > 1) ||
-             GetWifiRemoteStationManager()->GetVhtSupported());
+             m_mac->GetVhtConfiguration());
     }
 
     NS_LOG_FUNCTION(this << recipient << +tid << establish);
@@ -238,7 +239,8 @@
     auto tid = reqHdr->GetTid();
     respHdr.SetTid(tid);
 
-    respHdr.SetBufferSize(GetSupportedBaBufferSize());
+    auto bufferSize = std::min(m_mac->GetMpduBufferSize(), m_mac->GetMaxBaBufferSize(originator));
+    respHdr.SetBufferSize(bufferSize);
     respHdr.SetTimeout(reqHdr->GetTimeout());
 
     WifiActionHeader actionHdr;
@@ -308,12 +310,6 @@
     m_mac->GetQosTxop(tid)->Queue(mpdu);
 }
 
-uint16_t
-HtFrameExchangeManager::GetSupportedBaBufferSize() const
-{
-    return 64;
-}
-
 void
 HtFrameExchangeManager::SendDelbaFrame(Mac48Address addr, uint8_t tid, bool byOriginator)
 {
@@ -329,16 +325,7 @@
 
     MgtDelBaHeader delbaHdr;
     delbaHdr.SetTid(tid);
-    if (byOriginator)
-    {
-        delbaHdr.SetByOriginator();
-        GetBaManager(tid)->DestroyOriginatorAgreement(addr, tid);
-    }
-    else
-    {
-        delbaHdr.SetByRecipient();
-        GetBaManager(tid)->DestroyRecipientAgreement(addr, tid);
-    }
+    byOriginator ? delbaHdr.SetByOriginator() : delbaHdr.SetByRecipient();
 
     WifiActionHeader actionHdr;
     WifiActionHeader::ActionValue action;
@@ -349,7 +336,7 @@
     packet->AddHeader(delbaHdr);
     packet->AddHeader(actionHdr);
 
-    m_mac->GetQosTxop(tid)->GetWifiMacQueue()->Enqueue(Create<WifiMpdu>(packet, hdr));
+    m_mac->GetQosTxop(tid)->Queue(Create<WifiMpdu>(packet, hdr));
 }
 
 bool
@@ -583,6 +570,12 @@
         return false;
     }
 
+    NS_ABORT_IF(txParams.m_acknowledgment->method != WifiAcknowledgment::BLOCK_ACK);
+
+    // the BlockAckReq frame is sent using the same TXVECTOR as the BlockAck frame
+    auto blockAcknowledgment = static_cast<WifiBlockAck*>(txParams.m_acknowledgment.get());
+    txParams.m_txVector = blockAcknowledgment->blockAckTxVector;
+
     // we can transmit the BlockAckReq frame
     SendPsduWithProtection(GetWifiPsdu(mpdu, txParams.m_txVector), txParams);
     return true;
@@ -1377,8 +1370,6 @@
     else
     {
         isBar = false;
-        GetWifiRemoteStationManager()
-            ->ReportAmpduTxStatus(recipient, 0, psdu->GetNMpdus(), 0, 0, txVector);
         std::set<uint8_t> tids = psdu->GetTids();
         NS_ABORT_MSG_IF(tids.size() > 1, "Multi-TID A-MPDUs not handled here");
         NS_ASSERT(!tids.empty());
@@ -1437,6 +1428,8 @@
     else
     {
         // we have to retransmit the data frames, if needed
+        GetWifiRemoteStationManager()
+            ->ReportAmpduTxStatus(recipient, 0, psdu->GetNMpdus(), 0, 0, txVector);
         if (!GetWifiRemoteStationManager()->NeedRetransmission(*psdu->begin()))
         {
             NS_LOG_DEBUG("Missed Block Ack, do not retransmit the data frames");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/ht/ht-frame-exchange-manager.h ns-3.41/src/wifi/model/ht/ht-frame-exchange-manager.h
--- ns-3.40/src/wifi/model/ht/ht-frame-exchange-manager.h	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/ht/ht-frame-exchange-manager.h	2024-02-09 14:44:08.585795000 -0800
@@ -26,8 +26,6 @@
 #include "ns3/wifi-psdu.h"
 
 class AmpduAggregationTest;
-class TwoLevelAggregationTest;
-class HeAggregationTest;
 
 namespace ns3
 {
@@ -46,10 +44,6 @@
   public:
     /// allow AmpduAggregationTest class access
     friend class ::AmpduAggregationTest;
-    /// allow TwoLevelAggregationTest class access
-    friend class ::TwoLevelAggregationTest;
-    /// allow HeAggregationTest class access
-    friend class ::HeAggregationTest;
 
     /**
      * \brief Get the type ID.
@@ -148,13 +142,6 @@
      * \param originator the MAC address of the originator.
      */
     void SendAddBaResponse(const MgtAddBaRequestHeader* reqHdr, Mac48Address originator);
-    /**
-     * Get the maximum supported buffer size for a Block Ack agreement. This value
-     * is typically included in ADDBA Response frames.
-     *
-     * \return the maximum supported buffer size for a Block Ack agreement
-     */
-    virtual uint16_t GetSupportedBaBufferSize() const;
 
     /**
      * Sends DELBA frame to cancel a block ack agreement with STA
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/ht/ht-phy.cc ns-3.41/src/wifi/model/ht/ht-phy.cc
--- ns-3.40/src/wifi/model/ht/ht-phy.cc	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/ht/ht-phy.cc	2024-02-09 14:44:08.589794900 -0800
@@ -537,7 +537,7 @@
     {                                                                                              \
         static WifiMode mcs = CreateHtMcs(x);                                                      \
         return mcs;                                                                                \
-    };
+    }
 
 GET_HT_MCS(0)
 GET_HT_MCS(1)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/interference-helper.cc ns-3.41/src/wifi/model/interference-helper.cc
--- ns-3.40/src/wifi/model/interference-helper.cc	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/interference-helper.cc	2024-02-09 14:44:08.589794900 -0800
@@ -53,12 +53,6 @@
 {
 }
 
-Event::~Event()
-{
-    m_ppdu = nullptr;
-    m_rxPowerW.clear();
-}
-
 Ptr<const WifiPpdu>
 Event::GetPpdu() const
 {
@@ -816,7 +810,7 @@
 InterferenceHelper::NiChanges::iterator
 InterferenceHelper::AddNiChangeEvent(Time moment, NiChange change, NiChangesPerBand::iterator niIt)
 {
-    return niIt->second.insert(GetNextPosition(moment, niIt), std::make_pair(moment, change));
+    return niIt->second.insert(GetNextPosition(moment, niIt), {moment, change});
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/interference-helper.h ns-3.41/src/wifi/model/interference-helper.h
--- ns-3.40/src/wifi/model/interference-helper.h	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/interference-helper.h	2024-02-09 14:44:08.589794900 -0800
@@ -48,7 +48,6 @@
      * \param rxPower the received power per band (W)
      */
     Event(Ptr<const WifiPpdu> ppdu, Time duration, RxPowerWattPerChannelBand&& rxPower);
-    ~Event();
 
     /**
      * Return the PPDU.
